/// <reference types="mousetrap" />
import React from 'react';
import PropTypes from 'prop-types';
export declare type Combo = string | string[];
export declare type ComboWithEventType = {
    combo: Combo;
    eventType?: string;
};
export declare type Sequence = Combo | ComboWithEventType;
export declare type Callback = (e: KeyboardEvent, combo: string) => any;
export interface SequenceHandler {
    combo: string | string[];
    callback: Callback;
    eventType?: string;
}
export interface HotKeyContext {
    hotKeyParent: HotKeys;
    hotKeyMap: KeyMap;
}
export interface KeyMap {
    [key: string]: Sequence;
}
export interface Handlers {
    [key: string]: Callback;
}
export declare type Navigator = (hotKeys: HotKeys) => string | string[] | null;
export interface HotKeysProps extends React.HTMLAttributes<HTMLElement> {
    children: React.ReactNode;
    name?: string;
    keyMap?: KeyMap;
    handlers?: Handlers;
    focusOnMount?: boolean;
    navigator?: {
        [key: string]: string | string[] | Navigator | null;
    };
    onNavigateIn?: (preLocation?: string) => void;
    onNavigateOut?: () => void;
}
export declare class HotKeys extends React.Component<HotKeysProps, {}> {
    static contextTypes: {
        hotKeyParent: PropTypes.Requireable<any>;
        hotKeyMap: PropTypes.Requireable<object>;
    };
    static childContextTypes: {
        hotKeyParent: PropTypes.Requireable<any>;
        hotKeyMap: PropTypes.Requireable<object>;
    };
    static defaultProps: {
        focusOnMount: boolean;
    };
    context: HotKeyContext;
    wrappedComponent: React.RefObject<HTMLDivElement>;
    mounted: boolean;
    focused: boolean;
    previousFocused: boolean;
    hotKeyMap: KeyMap;
    mousetrap: MousetrapInstance;
    name?: string;
    hotKeyChain: HotKeys[];
    focusOnMount: boolean;
    constructor(props: HotKeysProps);
    getChildContext(): HotKeyContext;
    componentWillMount(): void;
    componentDidMount(): void;
    setFocus(): void;
    componentDidUpdate(prevProps: HotKeysProps): void;
    componentWillUnmount(): void;
    buildMap(): {
        [x: string]: Sequence;
    };
    updateMap(): boolean;
    focus: (preLocation?: string | undefined) => void;
    navigateTo: (target: string | string[] | null) => void;
    updateHotKeys(force?: boolean, prevProps?: HotKeysProps): void;
    onFocus: (e: React.FocusEvent<HTMLElement>) => void;
    render(): JSX.Element;
}
export default HotKeys;
